/*	
 *	clipmisc.h
 *
 *	G[Ȃ낢łB
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Wed Dec 12 21:51:29 JST 2001 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_MISC_H__
#define __CLIP_MISC_H__

/*****************************************************************************
 *	ėp}N
 *****************************************************************************/

#define DIE()		die(__FILE__ "(%d)", __LINE__)
#ifdef DEBUG
#define ASSERT(exp)	(void)((exp) || (die(__FILE__ "(%d): %s", __LINE__, #exp), 0))
#else /*DEBUG*/
#define ASSERT(exp)	((void)0)
#endif /*DEBUG*/

/* rbg */
#define BTST(a, b)	(((char*)(a))[(b) / 8] &    1 << ((b) & 7) )
#define BCLR(a, b)	(((char*)(a))[(b) / 8] &= ~(1 << ((b) & 7)))
#define BSET(a, b)	(((char*)(a))[(b) / 8] |=   1 << ((b) & 7) )
#define BNOT(a, b)	(((char*)(a))[(b) / 8] ^=   1 << ((b) & 7) )

/* 8rbg */
#define RAND(s)		(((s) = (s) * 5 + 0x3711) >> 8 & 0xFF)

/*****************************************************************************
 *	G[
 *****************************************************************************/

/* G[bZ[W\AvOI܂B
 * [in]
 *	fmt,...		printf()̈ƓlłB
 * [note]
 *	* ̊֐͏Ԃ܂B
 */
void die(const char* fmt, ...);

#ifdef PIECE
/*****************************************************************************
 *	P/ECEpE[maint[[N
 *****************************************************************************/

/* AvP[V`̃Gg|CgłB
 * [out]
 *	߂l		IR[hB
 * [note]
 *	* AvP[VIɂ́Aʂ̕@܂B
 *	  1. main()ԂB
 *	  2. pceAppReqExit()Ă񂾌Ayield()ĂԁB
 */
int main();

/* VXeɐ܂B
 * [note]
 *	* AvP[V́AIyield()Ă΂Ȃ΂܂B
 */
void yield();

/* vOIɎs֐w肵܂B
 * [in]
 *	func		֐ւ̃|C^
 * [out]
 *	߂l		o^ł0Ԃ܂B
 *			s0ȊO̒lԂ܂B
 * [note]
 *	* ݂̎ł́Ao^ł֐͈łB
 *	  Ȃ킿Aatexit()𕡐ĂԂƁAڈȍ~͎s܂B
 */
int atexit(void (*func )());

/*****************************************************************************
 *	pceLCDDrawObject
 *****************************************************************************/

/* pceLCDDrawObjectCXg[EACXg[܂B
 * [note]
 *	* pceLCDDrawObjectɂ́Â悤Ȑ܂B
 *	- ]@DRW_NOMALAA]rbg}bv2bitf[^masktłꍇȊÓA
 *	  {pceLCDDrawObjectɏC܂BĂяo镪AxȂ܂B
 *	- ]`ɁA]rbg}bv͂ݏöw肷ƁA삵܂B
 *	- ]rbg}bv́A8sNZPʂ̃TCYō쐬ĂȂ΂܂B
 *	  ̐́AP/ECErbg}bv`̐ł̂ŁAɒӂKv͂܂B
 *	* AvP[VNɈxhook_LCDDrawObject()ĂсA
 *	  AvP[VIɂ͕Kunhook_LCDDrawObject()ǂłB
 */
void hook_LCDDrawObject();
void unhook_LCDDrawObject();

#endif /*PIECE*/

#endif /*__CLIP_MISC_H__*/
